<?php
function lnEnrollGetVars($eid) {
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();
    $vars = array();

    $enrollstable = $lntable['course_enrolls'];
    $enrollscolumn = &$lntable['course_enrolls_column'];

    $query = "SELECT *
              FROM $enrollstable
              WHERE $enrollscolumn[eid] = '" . lnVarPrepForStore($eid) ."'";

    $result = $dbconn->Execute($query);

	list($eid,$sid,$gid,$uid,$options,$status,$mentor,$start) = $result->fields;
	$vars['eid'] = $eid;
	$vars['sid'] = $sid;
    $vars['gid'] = $gid;
    $vars['uid'] = $uid;
    $vars['options'] = $options;
    $vars['status'] = $status;
    $vars['mentor'] = $mentor;
    $vars['start'] = $start;

    $result->Close();

	return($vars);
}

function lnSubmissionGetVars($sid) {
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();
    $vars = array();

    $submissionstable = $lntable['course_submissions'];
    $submissionscolumn = &$lntable['course_submissions_column'];

    $query = "SELECT $submissionscolumn[sid],$submissionscolumn[cid], $submissionscolumn[start], $submissionscolumn[instructor], $submissionscolumn[enroll], $submissionscolumn[active], $submissionscolumn[amountstd], $submissionscolumn[limitstd] 
              FROM $submissionstable
              WHERE $submissionscolumn[sid] = '" . lnVarPrepForStore($sid) ."'";

    $result = $dbconn->Execute($query);

	list($sid,$cid,$start,$instructor,$enroll,$active,$amount,$limit) = $result->fields;
	$vars['sid'] = $sid;
    $vars['cid'] = $cid;
    $vars['start'] = $start;
    $vars['instructor'] = $instructor;
    $vars['enroll'] = $enroll;
    $vars['active'] = $active;
	$vars['amount'] = $amount;
	$vars['limit'] = $limit;

    $result->Close();

	return($vars);
}


/**
* check instructor user
*/
function lnIsUserInstructor($sid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$instid= lnSessionGetVar('uid');

	$query = "SELECT $course_submissionscolumn[sid] 
						FROM $course_submissionstable 
						WHERE $course_submissionscolumn[sid]='". lnVarPrepForStore($sid) ."' AND $course_submissionscolumn[instructor]='". lnVarPrepForStore($instid)."' ";

	$result = $dbconn->Execute($query);

	return  $result->fields[0];
}


/**
* check user mentor
*/
function lnIsUserMentor($sid,$uid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];

	$instid= lnSessionGetVar('uid');
	$query = "SELECT $course_enrollscolumn[eid] 
						FROM $course_enrollstable 
						WHERE $course_enrollscolumn[sid]='". lnVarPrepForStore($sid) ."' AND $course_enrollscolumn[mentor]='". lnVarPrepForStore($instid)."' AND $course_enrollscolumn[uid]='". lnVarPrepForStore($uid)."'";

	$result = $dbconn->Execute($query);

	return  $result->fields[0];
}

function lnCourseInstructor($sid) {
	
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];
//	$course_tatable = $lntable['course_ta'];
//	$course_tacolumn = &$lntable['course_ta_column'];
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];

	$uid = lnSessionGetVar('uid');

//	$query = "SELECT $course_submissionscolumn[cid] FROM $course_submissionstable LEFT JOIN $course_tatable ON  $course_tacolumn[sid]=$course_submissionscolumn[sid]  WHERE $course_submissionscolumn[sid]='". lnVarPrepForStore($sid) ."' and ($course_submissionscolumn[instructor] ='". lnVarPrepForStore($uid) ."' OR $course_tacolumn[uid]='". lnVarPrepForStore($uid) ."')";

	$query = "SELECT $course_submissionscolumn[cid] FROM $course_submissionstable LEFT JOIN $course_enrollstable ON  $course_enrollscolumn[sid]=$course_submissionscolumn[sid]  WHERE $course_submissionscolumn[sid]='". lnVarPrepForStore($sid) ."' and ($course_submissionscolumn[instructor] ='". lnVarPrepForStore($uid) ."' OR $course_enrollscolumn[mentor]='". lnVarPrepForStore($uid) ."')";

//	echo $query;
	$result = $dbconn->Execute($query);
	
	return $result->fields[0];
}

function lnhasCourseMentor($sid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];
	$course_tatable = $lntable['course_ta'];
	$course_tacolumn = &$lntable['course_ta_column'];

	$uid = lnSessionGetVar('uid');
	$query = "SELECT $course_submissionscolumn[sid] 
						FROM $course_submissionstable, $course_tatable 
						WHERE $course_tacolumn[sid]=$course_submissionscolumn[sid] AND $course_submissionscolumn[sid]='". lnVarPrepForStore($sid) ."' AND $course_submissionscolumn[instructor]='". lnVarPrepForStore($uid)."'";

	$result = $dbconn->Execute($query);

	return  $result->fields[0];
}


/*
* get Learning Status
*/
function lnGetLearningStatus($uid,$lid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_trackingtable = $lntable['course_tracking'];
	$course_trackingcolumn = &$lntable['course_tracking_column'];

	$query = "SELECT $course_enrollscolumn[status] 
						FROM $course_trackingtable, $course_enrollstable
						WHERE $course_trackingcolumn[eid]=$course_enrollscolumn[eid] AND $course_trackingcolumn[lid]='". lnVarPrepForStore($lid) ."' AND $course_enrollscolumn[uid] = '".lnVarPrepForStore($uid)."' ";

	$result = $dbconn->Execute($query);

	return  $result->fields[0];
}	


/**
* find Lesson Start date
*/
function lnStartLesson($uid,$cid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];
	$course_trackingtable = $lntable['course_tracking'];
	$course_trackingcolumn = &$lntable['course_tracking_column'];

	$query = "SELECT MIN($course_trackingcolumn[atime]),MAX($course_trackingcolumn[atime])  
						FROM $course_trackingtable, $course_enrollstable, $course_submissionstable 
						WHERE $course_trackingcolumn[eid]=$course_enrollscolumn[eid] AND $course_enrollscolumn[sid]=$course_submissionscolumn[sid] AND $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' AND $course_enrollscolumn[uid] = '".lnVarPrepForStore($uid)."' ";

	$result = $dbconn->Execute($query);

	list($start,$end) = $result->fields;
	if (empty($start)) {
		return FALSE;
	}
	else {
		$sstart = date('Y-m-d',$start);
		$send = date('Y-m-d',$end);
		$stime = date('H:i', $start);
		$etime = date('H:i', $end);
		$ret = Date_Calc::dateFormat2($sstart, "%e/%m/%Y ").$stime .'-'. Date_Calc::dateFormat2($send, "%e/%m/%Y ").$etime;

		return $ret;
	}
}	


/*
* find number of learning lesson in a course
*/
function lnNoOfLearning($uid,$cid) {

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];
	$course_trackingtable = $lntable['course_tracking'];
	$course_trackingcolumn = &$lntable['course_tracking_column'];

	$query = "SELECT COUNT($course_trackingcolumn[lid]) 
						FROM $course_trackingtable, $course_enrollstable, $course_submissionstable 
						WHERE $course_trackingcolumn[eid]=$course_enrollscolumn[eid] AND $course_enrollscolumn[sid]=$course_submissionscolumn[sid] AND $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' AND $course_enrollscolumn[status]='"._LNSTATUS_STUDY."' AND $course_enrollscolumn[uid] = '".lnVarPrepForStore($uid)."'  GROUP BY $course_trackingcolumn[lid]";
	
	$result = $dbconn->Execute($query);

	$sum_lesson = $result->PO_RecordCount();

	return $sum_lesson;
}


/**
* find number of lesson in a course
*/
function lnNoOfLesson($cid) {

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$lessonstable = $lntable['lessons'];
	$lessonscolumn = &$lntable['lessons_column'];

	$query = "SELECT COUNT($lessonscolumn[lid]) 
						FROM $lessonstable 
						WHERE $lessonscolumn[cid]='". lnVarPrepForStore($cid) ."'";

	$result = $dbconn->Execute($query);
	list($sum_lesson) = $result->fields;
	
	return $sum_lesson;
}


/*
* find compleate course
*/
function lnCompleteCourse($cid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$lessonstable = $lntable['lessons'];
	$lessonscolumn = &$lntable['lessons_column'];
	$scorestable = $lntable['scores'];
	$scorescolumn = &$lntable['scores_column'];
	$quiztable = $lntable['quiz'];
	$quizcolumn = &$lntable['quiz_column'];

	$query = "SELECT $lessonscolumn[lid] FROM $lessonstable WHERE $lessonscolumn[cid]='$cid'";
	$result = $dbconn->Execute($query);
	$pass = true;
	while(list($lid) = $result->fields) {
			$result->MoveNext();
			if (hasLessonTest($lid)) {
				$query = "SELECT MAX($scorescolumn[score]),$quizcolumn[option] FROM $scorestable,$quiztable
						WHERE $scorescolumn[qid]=$quizcolumn[qid] AND $quizcolumn[lid]='$lid' GROUP BY $quizcolumn[lid]";
				$result2 = $dbconn->Execute($query);
				list($maxscore,$option) = $result2->fields;
				if ($maxscore < _LNPASS_SCORE && $option & 2) {
					$pass=false;
					break;
				}
			}
			if (lnGetLearningStatus(lnSessionGetVar('uid'),$lid) == "") {
				$pass=false;
				break;
			}
	}

	return $pass;
}

/*
* find sum course length
*/
function lnCourseLength($cid) {
	// Get arguments from argument array
    extract($vars);

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	$lessonstable = $lntable['lessons'];
	$lessonscolumn = &$lntable['lessons_column'];

	$query = "SELECT SUM($lessonscolumn[duration]) 
						FROM $lessonstable 
						WHERE $lessonscolumn[cid]='". lnVarPrepForStore($cid) ."'";

	$result = $dbconn->Execute($query);
	list($course_length) = $result->fields;
	
	if (empty($course_length)) {
		$course_length = '1';
	}
	return $course_length;
}


/*
* find Course date duration
*/
function lnCourseDate($cid) {
	$course_length = lnCourseLength($cid) - 1;
	$start = lnGetStartDateEnroll(lnGetEnroll($cid));
	$from = Date_Calc::dateFormat2($start, "%e %b");
	$to = Date_Calc::daysAddtoDate2($start, $course_length, "%e %b %y");
	
	$ret = $from . ' - ' . $to;

	return $ret;
}	


/*
* find start date without enroll
*/
function lnGetStartDateSubmission($sid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$query = "SELECT $course_submissionscolumn[start] FROM $course_submissionstable WHERE $course_submissionscolumn[sid]='". lnVarPrepForStore($sid)."'";
	$result = $dbconn->Execute($query);			
	
	return  $result->fields[0];
}

/*
* find enroll with submissions ID
* return SID 
*/
function lnGetSubmission($cid) {

	$uid = lnSessionGetVar('uid');

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$result = $dbconn->Execute("SELECT $course_enrollscolumn[sid] FROM $course_enrollstable, $course_submissionstable WHERE $course_enrollscolumn[sid]= $course_submissionscolumn[sid] and $course_enrollscolumn[uid]='". lnVarPrepForStore($uid) ."' and $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_enrollscolumn[status]='0'");			
	list($sid) = $result->fields;
	
	if (empty($sid)) {
		return false;
		
	}
	else {
		return $sid;
	}
}	


/*
* show course tab menu
*/
function tabMenu($vars,$no) {
	// Get arguments from argument array
		extract($vars);
		$uid = lnSessionGetVar('uid');
		//by Xeonkung
		$courseinfo = lnCourseGetVars($cid);
		$coursecode= $courseinfo['code'];
		$coursename = $courseinfo['title'];

		if (empty($sid)) {
			$sid = lnGetSubmissionID($cid);
		}
		if (!empty($sid)) {
			$start = lnGetStartDateSubmission($sid); 			
			$course_length = lnCourseLength($cid) - 1;
			$from = Date_Calc::dateFormat2($start, "%e %b");
			$to = Date_Calc::daysAddtoDate2($start, $course_length, "%e %b %y");
			$duration = $from . ' - ' . $to;
			echo '<IMG SRC="images/global/linkicon.gif" WIDTH="9" HEIGHT="9" BORDER=0 ALT=""> <B>'.$courseinfo[code].': '.stripslashes($courseinfo[title]).' ('.$duration.')</B>';
		}
		else {
			echo '<IMG SRC="images/global/linkicon.gif" WIDTH="9" HEIGHT="9" BORDER=0 ALT=""> <B>'.$courseinfo[code].': '.stripslashes($courseinfo[title]).'</B>';
		}

		$menus = array();
		$ops = array();
		$imgs = array();
	
		echo '<BR>&nbsp;<div class="taMenu">';

		echo '<table  border="0" cellspacing="0" cellpadding="0"><tr><td>';
	
		if ($no == '1') {
			echo '<td><li id="current"><a class=tab href="index.php?mod=Courses&amp;op=course_detail&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEDESCRIPTION.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class=tab href="index.php?mod=Courses&amp;op=course_detail&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEDESCRIPTION.'</span></a></li></td>';
		}

		
		if ($no == '2') {
			echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=course_lesson&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSECONTENT.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;op=course_lesson&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSECONTENT.'</span></a></li></td>';
		}

	if ((lnUserLoggedIn() && lnGetEnroll($cid)) || lnCourseInstructor($sid)) {
		
		if (lnModAvailable('Forums')) {
			if ($no == '3') {
				echo '<td><li id="current"><a class="tab" href="index.php?mod=Forums&amp;op=forum_list&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._WEBBOARD.'</span></a></li></td>';
			}
			else {
				echo '<td><li><a class="tab" href="index.php?mod=Forums&amp;op=forum_list&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._WEBBOARD.'</span></a></li></td>';
			}
		}
		/* Comment Chat Tab
		if (lnModAvailable('Chat')) {
			if ($no == '4') {
				echo '<td><li id="current"><a class="tab" href="index.php?mod=Chat&amp;op=chat&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._CHATROOM.'</span></a></li></td>';
			}
			else {
				echo '<td><li><a class="tab" href="index.php?mod=Chat&amp;op=chat&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._CHATROOM.'</span></a></li></td>';
			}
		}
		*/		
		if (!lnCourseInstructor($sid)){	//by Xeokung
			if ($no == '4') {
				echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&op=report_graph&uid='.$uid.'&cid='.$cid.'&sid='.$sid.'"><span>'._SHISTORY.'</span></a></li></td>';
			}
			else {
				echo '<td><li><a class="tab" href="index.php?mod=Courses&op=report_graph&uid='.$uid.'&cid='.$cid.'&sid='.$sid.'"><span>'._SHISTORY.'</span></a></li></td>';
			}
			if ($no == '5') {
				echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=roster&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._ROSTER.'</span></a></li></td>';
			}
			else {
				echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;op=roster&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._ROSTER.'</span></a></li></td>';
			}
		}
	}
	else {
		if  (lnUserLoggedIn() && lnSecAuthAction(0, "Courses::Student", "::", ACCESS_READ) &&  (lnGetEnrollStatus(lnSessionGetVar('uid'), $sid) != _LNSTATUS_STUDY)) {
			if ($no == '3') {
				echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=course_enroll&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._ENROLL.'</span></a></li></td>';
			}
			else {
				echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;op=course_enroll&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._ENROLL.'</span></a></li></td>';
			}
		}
	}
	
	if (lnCourseInstructor($sid)) {
		if ($no == '6') {
			echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=report&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEREPORT.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;op=report&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEREPORT.'</span></a></li></td>';
		}
		if ($no == '7') {
			echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=report_detail&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEDETAIL.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab"  href="index.php?mod=Courses&amp;op=report_detail&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSEDETAIL.'</span></a></li></td>';
		}
		
		
//Objective : Add Summary tab  , programmer : Orrawin
		if ($no == '8') {
			echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=report_summary&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSESUMMARY.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab"  href="index.php?mod=Courses&amp;op=report_summary&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._COURSESUMMARY.'</span></a></li></td>';
		}
//*************end Add Summary tab *****************
		
//Objective : Add Questionaire Summary tab  , programmer : Orrawin
		if ($no == '9') {
			echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;op=questionaire_summary&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._QUESTIONAIRESUMMARY.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab"  href="index.php?mod=Courses&amp;op=questionaire_summary&amp;cid='.$cid.'&amp;sid='.$sid.'"><span>'._QUESTIONAIRESUMMARY.'</span></a></li></td>';
		}
//*************end Add Questionaire Summary tab *****************	
	}

	echo '</td></tr></table>';

	echo '</div>';
}


/*
* tab admin course menu
*/
function tabCourseAdmin($cid,$no) {

	echo '<div class="taMenu">';

	echo '<table border="0" cellspacing="0" cellpadding="0"><tr>';
	if ($no == '1') {
		echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=edit_course&amp;cid='.$cid.'"><span>'._COURSEDESCRIPTION.'</span></a></li></td>';
	}
	else {
		echo '<td><li><a class="tab"  href="index.php?mod=Courses&amp;file=admin&amp;op=edit_course&amp;cid='.$cid.'"><span>'._COURSEDESCRIPTION.'</span></a></li></td>';
	}
	if ($no == '2') {
		echo '<td><li id="current"><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=lesson&amp;cid='.$cid.'"><span>'._COURSELESSON.'</span></a></li></td>';
	}
	else {
		echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=lesson&amp;cid='.$cid.'"><span>'._COURSELESSON.'</span></a></li></td>';
	}

	if ($no == '3') {
		echo '<td><li id="current"><a class="tab"  href="index.php?mod=Courses&amp;file=admin&amp;op=quiz&amp;cid='.$cid.'"><span>'._COURSETEST.'</span></a></li></td>';
	}
	else {
		echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=quiz&amp;cid='.$cid.'"><span>'._COURSETEST.'</span></a></li></td>';
	}

	if (hasLesson($cid) && !lnAllTime($cid)) {

	if ($no == '4') {
			echo '<td><li id="current"><a class="tab"  href="index.php?mod=Courses&amp;file=admin&amp;op=schedule&amp;cid='.$cid.'"><span>'._COURSESCHEDULE.'</span></a></li></td>';
		}
		else {
			echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=schedule&amp;cid='.$cid.'"><span>'._COURSESCHEDULE.'</span></a></li></td>';
		}

	}

	if ($no == '5') {
		echo '<td><li id="current"><a class="tab"  href="index.php?mod=Courses&amp;file=admin&amp;op=upfile&amp;cid='.$cid.'"><span>'._COURSEUPLOAD.'</span></a></li></td>';
	}
	else {
		echo '<td><li><a class="tab" href="index.php?mod=Courses&amp;file=admin&amp;op=upfile&amp;cid='.$cid.'"><span>'._COURSEUPLOAD.'</span></a></li></td>';
	}

	echo '</tr></table>';
	echo '</div>';
}


function lnAllTime($cid) {
	$courseinfo = lnCourseGetVars($cid);
	 if ($courseinfo['sequence'] == '1') {
		return true;
	 }
	else {
		return false;
	}
}

function lnCourseGetVars($cid) {
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();
    $vars = array();

    $coursestable = $lntable['courses'];
    $coursescolumn = &$lntable['courses_column'];

    $query = "SELECT $coursescolumn[cid],$coursescolumn[code], $coursescolumn[sid], $coursescolumn[title], $coursescolumn[author], $coursescolumn[description],$coursescolumn[createon],$coursescolumn[purpose], $coursescolumn[prerequisite], $coursescolumn[reference],$coursescolumn[sequence] 
              FROM $coursestable
              WHERE $coursescolumn[cid] = '" . lnVarPrepForStore($cid) ."'";

    $result = $dbconn->Execute($query);
	list($cid,$code,$sid, $title,$author,$description,$createon,$purpose,$prerequisite,$reference,$sequence) = $result->fields;
	$vars['cid'] = $cid;
    $vars['code'] = $code;
    $vars['sid'] = $sid;
    $vars['title'] = $title;
    $vars['author'] = $author;
    $vars['description'] = $description;
    $vars['createon'] = $createon;
    $vars['purpose'] = $purpose;
    $vars['prerequisite'] = $prerequisite;
    $vars['reference'] = $reference;
	$vars['sequence'] = $sequence;

    $result->Close();

return($vars);
}

function lnLessonGetVars($lid) {
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();
    $vars = array();

    $lessonstable = $lntable['lessons'];
    $lessonscolumn = &$lntable['lessons_column'];

    $query = "SELECT $lessonscolumn[lid],$lessonscolumn[cid], $lessonscolumn[title], $lessonscolumn[description], $lessonscolumn[file], $lessonscolumn[duration],$lessonscolumn[weight],$lessonscolumn[lid_parent],$lessonscolumn[type]
              FROM $lessonstable
              WHERE $lessonscolumn[lid] = '" . lnVarPrepForStore($lid) ."'";

    $result = $dbconn->Execute($query);
	list($lid,$cid,$title,$description,$file,$duration,$weight,$lid_parent,$type) = $result->fields;
	$vars['lid'] = $lid;
	$vars['cid'] = $cid;
    $vars['title'] = $title;
    $vars['description'] = $description;
    $vars['file'] = $file;
    $vars['duration'] = $duration;
    $vars['weight'] = $weight;
    $vars['lid_parent'] = $lid_parent;
    $vars['type'] = $type;
	$nos = lnGetLessonNo($lid,$nos=array());
	$no= join ('.',$nos);

	$vars['no']=$no;

    $result->Close();

return($vars);
}

function lnQuizGetVars($qid) {		//bas edit: add assessment
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();
    $vars = array();

    $quiztable = $lntable['quiz'];
    $quizcolumn = &$lntable['quiz_column'];

    $query = "SELECT $quizcolumn[qid],$quizcolumn[cid],$quizcolumn[name],$quizcolumn[intro],$quizcolumn[attempts],$quizcolumn[feedback],$quizcolumn[correctanswers],$quizcolumn[grademethod],$quizcolumn[shufflequestions],$quizcolumn[testtime],$quizcolumn[grade],$quizcolumn[assessment]
              FROM $quiztable
              WHERE $quizcolumn[qid] = '" . lnVarPrepForStore($qid) ."'";
//echo $query;
    $result = $dbconn->Execute($query);
	list($qid,$cid,$name,$intro, $attempts,$feedback,$correctanswers,$grademethod,$shufflequestions,$testtime,$grade,$assessment) = $result->fields;
	$vars['qid'] = $qid;
    $vars['cid'] = $cid;
    $vars['name'] = $name;
    $vars['intro'] = $intro;
    $vars['attempts'] = $attempts;
    $vars['feedback'] = $feedback;
    $vars['correctanswers'] = $correctanswers;
    $vars['grademethod'] = $grademethod;
    $vars['shufflequestions'] = $shufflequestions;
	$vars['testtime'] = $testtime;
	$vars['grade'] = $grade;
	$vars['assessment'] = $assessment;

    $result->Close();

return($vars);
}


function lnGetLessonNo($lid,$nos) {

	if ($lid != 0 ) {
		 list($dbconn) = lnDBGetConn();
		$lntable = lnDBGetTables();

		$lessonstable = $lntable['lessons'];
		$lessonscolumn = &$lntable['lessons_column'];
		$result = $dbconn->Execute("SELECT $lessonscolumn[lid_parent],$lessonscolumn[weight] FROM $lessonstable WHERE $lessonscolumn[lid]='$lid'");
		list($lid_parent,$weight) = $result->fields;
//		echo '>';
//		print_r($nos);
		$nos = lnGetLessonNo($lid_parent,$nos);
		array_push($nos,$weight);
//		echo '<BR>>>';
//		print_r($nos);
		return $nos;
}
	else {
		return $nos;
	}
}

function lnGetCourseID($sid) {
	
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$coursestable = $lntable['courses'];
	$coursescolumn = &$lntable['courses_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$uid = lnSessionGetVar('uid');

	$query = "SELECT $coursescolumn[cid] FROM $course_submissionstable,$coursestable WHERE $course_submissionscolumn[cid]=$coursescolumn[cid] and $course_submissionscolumn[sid]='$sid'";
	$result = $dbconn->Execute($query);
	
	return $result->fields[0];
}


/**
* get Score
*/
function lnGetScore($uid, $lid) {

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$scorestable = $lntable['scores'];
	$scorescolumn = &$lntable['scores_column'];
	$quiztable = $lntable['quiz'];
	$quizcolumn = &$lntable['quiz_column'];
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$lessonstable = $lntable['lessons'];
	$lessonscolumn = &$lntable['lessons_column'];	

	$query0 = "SELECT $lessonscolumn[file] FROM $lessonstable WHERE $lessonscolumn[lid]='$lid'";
	$result0 = $dbconn->Execute($query0);
	list($qid) = $result0->fields;

	$query1 = "SELECT $quizcolumn[grademethod] FROM $quiztable WHERE $quizcolumn[qid]='$qid'";
	$result1 = $dbconn->Execute($query1);
	list($qrademethod) = $result1->fields;
	
	if($qrademethod=='1')
	{
		$query  = "SELECT max($scorescolumn[score]) FROM $scorestable, $course_enrollstable";
		$query .= " WHERE $course_enrollscolumn[eid]=$scorescolumn[eid] ";
		$query .= " AND $scorescolumn[lid]='$lid'  AND $course_enrollscolumn[uid]='$uid'";	
	}
	else 
	if($qrademethod=='2')
	{
		$query  = "SELECT avg($scorescolumn[score]) FROM $scorestable, $course_enrollstable";
		$query .= " WHERE $course_enrollscolumn[eid]=$scorescolumn[eid] ";
		$query .= " AND $scorescolumn[lid]='$lid'  AND $course_enrollscolumn[uid]='$uid'";	
	}
	else 
	if($qrademethod=='3')
	{
		$query  = "SELECT $scorescolumn[score] FROM $scorestable, $course_enrollstable";
		$query .= " WHERE $course_enrollscolumn[eid]=$scorescolumn[eid] ";
		$query .= " AND $scorescolumn[lid]='$lid'  AND $course_enrollscolumn[uid]='$uid' ORDER BY $scorescolumn[quiz_time] ASC";	
	
		$result = $dbconn->Execute($query);

		$rets = array();
		while(list($score) = $result->fields) {
			$result->MoveNext();
			$rets[]=' '.$score.'%';
		}
		$score = $rets[count($rets)-1];
		return $score;
	}
	else
	{
		$query  = "SELECT avg($scorescolumn[score]) FROM $scorestable, $course_enrollstable";
		$query .= " WHERE $course_enrollscolumn[eid]=$scorescolumn[eid] ";
		$query .= " AND $scorescolumn[lid]='$lid'  AND $course_enrollscolumn[uid]='$uid'";			
	}
	
	$result = $dbconn->Execute($query);	
	return $result->fields[0];
}


function lnCourseNextID() {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$coursestable = $lntable['courses'];
	$coursescolumn = &$lntable['courses_column'];
	$query = "SELECT MAX($coursescolumn[cid]) FROM $coursestable";
	
	$result = $dbconn->Execute($query);

	return $result->fields[0] + 1;
}


function lnLessonNextID() {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$lessonstable = $lntable['lessons'];
	$lessonscolumn = &$lntable['lessons_column'];
	$query = "SELECT MAX($lessonscolumn[lid]) FROM $lessonstable";
	
	$result = $dbconn->Execute($query);

	return $result->fields[0] + 1;
}

function lnQuizNextID() {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$quiztable = $lntable['quiz'];
	$quizcolumn = &$lntable['quiz_column'];
	$query = "SELECT MAX($quizcolumn[qid]) FROM $quiztable";
	
	$result = $dbconn->Execute($query);

	return $result->fields[0] + 1;
}

function lnQuizQuestionNextID() {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$quiz_questiontable = $lntable['quiz_multichoice'];
	$quiz_questioncolumn = &$lntable['quiz_multichoice_column'];
	$query = "SELECT MAX($quiz_questioncolumn[mcid]) FROM $quiz_questiontable";
	
	$result = $dbconn->Execute($query);

	return $result->fields[0] + 1;
}

function lnQuizChoiceNextID() {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$quiz_choicetable = $lntable['quiz_choice'];
	$quiz_choicecolumn = &$lntable['quiz_choice_column'];
	$query = "SELECT MAX($quiz_choicecolumn[chid]) FROM $quiz_choicetable";
	
	$result = $dbconn->Execute($query);

	return $result->fields[0] + 1;
}

function lnShowNew($createon) {
	$date1=date('Y-m-d');
	$date2=date('Y-m-d',$createon);
	if (Date_Calc::dateDiff2($date1,$date2) < 30) {;
		echo '<IMG SRC="images/new.gif" WIDTH="28" HEIGHT="11" BORDER=0 ALT="">';
	}
}


/*
* show answer
*/
function lnShowAnswer($qid) {

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$quiztable = $lntable['quiz'];
	$quizcolumn = &$lntable['quiz_column'];

	$query = "SELECT $quizcolumn[option] FROM $quiztable WHERE $quizcolumn[qid]='$qid'";

	$result = $dbconn->Execute($query);

	return $result->fields[0] & 1;
}


/**
*
*/
function  lnEnrollEnable($cid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$query = "SELECT $course_submissionscolumn[start],
										  $course_submissionscolumn[enroll] 
										FROM $course_submissionstable WHERE $course_submissionscolumn[cid]='$cid' AND $course_submissionscolumn[active]='1'";
	$result = $dbconn->Execute($query);
	
	$m=0;
	while(list($start,$enroll) = $result->fields) {
		$result->MoveNext();
		if ($enroll != 1) {  // no enroll before
			$m++;
		}
	}
			
	if ($m==1 && Date_Calc::isPastDate2($start)) {
		return false;
	}
	else {
		return true;
	}


}

function lnGetEnrollStatus($uid, $sid) {
	$status = array('learning','complete','drop');
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];

	$query  = "SELECT $course_enrollscolumn[status] FROM $course_enrollstable";
	$query .= " WHERE $course_enrollscolumn[sid]='$sid' AND $course_enrollscolumn[uid]='$uid'";
	$result = $dbconn->Execute($query);

	return $result->fields[0];
}


function lnGetEnrollID($uid, $sid) {
	
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();

	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];

	$query  = "SELECT $course_enrollscolumn[eid] FROM $course_enrollstable";
	$query .= " WHERE $course_enrollscolumn[sid]='$sid' AND $course_enrollscolumn[uid]='$uid'";
	$result = $dbconn->Execute($query);
	list($eid) = $result->fields;
	return $eid;
}


/*
* find enroll typewith couseID
* return enroll ID 
*/
function lnEnrollType($cid) {

	$uid = lnSessionGetVar('uid');

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$result = $dbconn->Execute("SELECT $course_submissionscolumn[study] FROM $course_enrollstable, $course_submissionstable WHERE $course_enrollscolumn[sid]= $course_submissionscolumn[sid] and $course_enrollscolumn[uid]='". lnVarPrepForStore($uid) ."' and $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_enrollscolumn[status]='0'");			
	list($type) = $result->fields;
	
	if (empty($type)) {
		return false;
	}
	else {
		return $type;
	}
}	

/*
* find start date
*/
function lnGetStartDateEnroll($eid) {
	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$query = "SELECT $course_submissionscolumn[start] FROM $course_enrollstable, $course_submissionstable WHERE $course_enrollscolumn[sid]=$course_submissionscolumn[sid] and $course_enrollscolumn[eid]='". lnVarPrepForStore($eid)."'";
	$result = $dbconn->Execute($query);			
	
	return  $result->fields[0];
}

/*
* find enroll with couseID
* return enroll ID 
*/
function lnGetEnroll($cid) {

	$uid = lnSessionGetVar('uid');

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];

	$result = $dbconn->Execute("SELECT $course_enrollscolumn[eid] FROM $course_enrollstable, $course_submissionstable WHERE $course_enrollscolumn[sid]= $course_submissionscolumn[sid] and $course_enrollscolumn[uid]='". lnVarPrepForStore($uid) ."' and $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_enrollscolumn[status]='"._LNSTATUS_STUDY."'");	
	
	list($eid) = $result->fields;
	
	if (empty($eid)) {
		return false;
	}
	else {
		return $eid;
	}
}	

function lnGetSubmissionID($cid) {

	list($dbconn) = lnDBGetConn();
	$lntable = lnDBGetTables();
	
	$course_enrollstable = $lntable['course_enrolls'];
	$course_enrollscolumn = &$lntable['course_enrolls_column'];
	$course_submissionstable = $lntable['course_submissions'];
	$course_submissionscolumn = &$lntable['course_submissions_column'];
	$course_tatable = $lntable['course_ta'];
	$course_tacolumn = &$lntable['course_ta_column'];
	
	// all guest users 
	$result = $dbconn->Execute("SELECT $course_submissionscolumn[sid] FROM $course_submissionstable WHERE $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_submissionscolumn[instructor]='"._LNSTUDENT_GUEST."'");	
	list($sid) = $result->fields;
	
	if (!empty($sid)) {
		return $sid;
	}

	// member users 
	$result = $dbconn->Execute("SELECT $course_submissionscolumn[sid] FROM $course_submissionstable WHERE $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_submissionscolumn[instructor]='"._LNSTUDENT_USER."'");	
	list($sid) = $result->fields;

	if (!empty($sid) && lnUserLoggedIn()) {
		return $sid;
	}


	// enroll or selected users
	$uid = lnSessionGetVar('uid');

	$result = $dbconn->Execute("SELECT $course_submissionscolumn[sid] FROM $course_enrollstable, $course_submissionstable WHERE $course_enrollscolumn[sid]= $course_submissionscolumn[sid] and $course_enrollscolumn[uid]='". lnVarPrepForStore($uid) ."' and $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_enrollscolumn[status]='"._LNSTATUS_STUDY."'");	
	list($sid) = $result->fields;
	
	if (!empty($sid)) {
		return $sid;
	}

	// teacher users 
	$result = $dbconn->Execute("SELECT $course_submissionscolumn[sid] FROM $course_submissionstable WHERE $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_submissionscolumn[instructor]='". lnVarPrepForStore($uid) ."'");	
	list($sid) = $result->fields;

	if (!empty($sid)) {
		return $sid;
	}

	// ta users 
	$result = $dbconn->Execute("SELECT $course_submissionscolumn[sid] FROM $course_submissionstable,$course_tatable WHERE $course_submissionscolumn[sid]=$course_tacolumn[sid] and $course_submissionscolumn[cid]='". lnVarPrepForStore($cid) ."' and $course_tacolumn[uid]='". lnVarPrepForStore($uid) ."'");	
	list($sid) = $result->fields;

	if (!empty($sid)) {
		return $sid;
	}
	return false;
}	

function lnGetSID($eid) {
    list($dbconn) = lnDBGetConn();
    $lntable = lnDBGetTables();

    $enrollstable = $lntable['course_enrolls'];
    $enrollscolumn = &$lntable['course_enrolls_column'];

    $query = "SELECT $enrollscolumn[sid]
              FROM $enrollstable
              WHERE $enrollscolumn[eid] = '" . lnVarPrepForStore($eid) ."'";
              
    	$result = $dbconn->Execute($query);
	list($sid) = $result->fields;
	
	if (!empty($sid)) {
		return $sid;
	}
	return false;
}

?>