<?php
/**
*  Export Course
*/
if (!defined("LOADED_AS_MODULE")) {
	die ("You can't access this file directly...");
}
if (!lnSecAuthAction(0, 'SCORM::', "::", ACCESS_READ)) {
	echo "<CENTER><h1>"._NOAUTHORIZED." to read ".$mod." module!</h1></CENTER>";
	return false;
}

/* - - - - - - - - - - - */
define(AT_INCLUDE_PATH,'modules/SCORM/');
require(AT_INCLUDE_PATH.'classes/zipfile.class.php');														/* for zipfile */
require(AT_INCLUDE_PATH.'ims/ims_template.inc.php');														/* for ims templates + print_organizations() */

$vars= array_merge($GLOBALS['HTTP_GET_VARS'],$GLOBALS['HTTP_POST_VARS']);

switch ($op) {
	case "export_course" :	
		/* to avoid timing out on large files */
		set_time_limit(0);

		$courseinfo = lnCourseGetVars($cid);
		$ims_course_title = str_replace(' ', '_', $courseinfo['title']);
		$full_course_title = $courseinfo['title'];
		$ims_course_description= htmlspecialchars($courseinfo['description']);

		/* generate the imsmanifest.xml header attributes */
		$imsmanifest_xml = str_replace(array('{COURSE_TITLE}','{COURSE_DESCRIPTION}'), array($ims_course_title,$ims_course_description), $ims_template_xml['header']);

		$zipfile = new zipfile(); 

		/* get all the content */
		$content = array();
		$paths	 = array();
		$top_content_parent_id = 0;

		$handler=new MyHandler();
		$parser =& new XML_HTMLSax();
		$parser->set_object($handler);
		$parser->set_element_handler('openHandler','closeHandler');
		$vars = array();

		 list($dbconn) = lnDBGetConn();
		$lntable = lnDBGetTables();
		
		$lessonstable = $lntable['lessons'];
		$lessonscolumn = &$lntable['lessons_column'];
		$quiztable = $lntable['quiz'];
		$quizcolumn = &$lntable['quiz_column'];
		$quiz_questiontable = $lntable['quiz_question'];
		$quiz_questioncolumn = &$lntable['quiz_question_column'];
		$quiz_choicetable = $lntable['quiz_choice'];
		$quiz_choicecolumn = &$lntable['quiz_choice_column'];

		$query="SELECT $lessonscolumn[lid] as LessonID, $lessonscolumn[cid] as CourseID, $lessonscolumn[title] as LessonTitle, $lessonscolumn[description] Abstract, $lessonscolumn[file] as LessonFile, $lessonscolumn[duration] as Length FROM $lessonstable WHERE $lessonscolumn[cid]='$cid' ORDER BY  $lessonscolumn[weight]";
		
		$result = $dbconn->Execute($query);
		while(list($lid,$cid,$title,$abstract,$file,$length) = $result->fields) {
			$result->MoveNext();
			$row = array('LessonID'=>"$lid",'CourseID'=>"$cid",'LessonTitle'=>"$title",'Abstract'=>"$abstract",'LessonFile'=>"$file",'Length'=>"$length");
			$content[] = $row;
		}

		$top_content_parent_id= $courseinfo['code'];

		ob_start();
		print_organizations( $courseinfo['code'], $content, 0, '', array(), $toc_html);
		$organizations_str = ob_get_contents();
		ob_clean();

		$toc_html = str_replace('{TOC}', $toc_html, $html_toc);

		$frame = str_replace(	array('{COURSE_TITLE}',		'{FIRST_ID}'),
								array($ims_course_title, $content[0]['LessonFile']),
								$html_frame);

		$html_mainheader = str_replace('{COURSE_TITLE}', $full_course_title, $html_mainheader);
								
		/* append the Organizations and Resources to the imsmanifest */
		$imsmanifest_xml .= str_replace(	array('{COURSE_TITLE}','{ORGANIZATIONS}',	'{RESOURCES}'),
									array($ims_course_title, $organizations_str, $resources),
									$ims_template_xml['final']);


		$query = "SELECT $quizcolumn[qid], $quizcolumn[lid], $quizcolumn[description],$quizcolumn[type], $quizcolumn[random], $quizcolumn[timelimit],$quizcolumn[option] FROM $quiztable WHERE $quizcolumn[cid]='".$courseinfo['cid']."'";
		$result = $dbconn->Execute($query);

		while(list($qid,$lid,$description,$quiz_type,$random,$timelimit,$option) = $result->fields) {
			$result->MoveNext();
				$quizs='';
				$quiz= "$qid::$lid::$description::$quiz_type::$random::$timelimit::$option";
				$questions=array();
				$query = "SELECT $quiz_questioncolumn[quid], $quiz_questioncolumn[question], $quiz_questioncolumn[answer], $quiz_questioncolumn[score] FROM $quiz_questiontable WHERE  $quiz_questioncolumn[qid]='$qid' ORDER BY $quiz_questioncolumn[weight]";
				$result2 = $dbconn->Execute($query);
				while(list($quid,$question,$answer,$score) = $result2->fields) {
						$result2->MoveNext();
						$choices=array();
						$quiztitle = "$question::$answer::$score::";
						$query = "SELECT $quiz_choicecolumn[chid], $quiz_choicecolumn[choice], $quiz_choicecolumn[description] FROM $quiz_choicetable WHERE $quiz_choicecolumn[quid]='$quid' ORDER BY $quiz_choicecolumn[weight]";
						$result3 = $dbconn->Execute($query);
						while(list($chid,$choice,$choice_desc) = $result3->fields) {
							$result3->MoveNext();
							$choices[] = "$choice::$choice_desc";
						}
						$questions[]=$quiztitle."|||". join("==",$choices);
				}
				$quizs = $quiz."@@@".join("###",$questions);
				$zipfile->add_file($quizs, _QUESTIONPREFIX.$lid.'_'.$quiz_type.'.txt');
			}



		/* zip the entire ims export directory and send to the user */
		$zipfile->add_file($frame, 'index.html');
		$zipfile->add_file($toc_html, 'toc.html');
		$zipfile->add_file($imsmanifest_xml, 'imsmanifest.xml');
		$zipfile->add_file($html_mainheader, 'header.html');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/ims.css'), 'ims.css');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/footer.html'), 'footer.html');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/logo.gif'), 'logo.gif');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/adlcp_v1p3.xsd'), 'adlcp_v1p3.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/adlnav_v1p3.xsd'), 'adlnav_v1p3.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/adlseq_v1p3.xsd'), 'adlseq_v1p3.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imscp_v1p1.xsd'), 'imscp_v1p1.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0.xsd'), 'imsss_v1p0.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0auxresource.xsd'), 'imsss_v1p0auxresource.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0control.xsd'), 'imsss_v1p0control.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0delivery.xsd'), 'imsss_v1p0delivery.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0limit.xsd'), 'imsss_v1p0limit.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0objective.xsd'), 'imsss_v1p0objective.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0random.xsd'), 'imsss_v1p0random.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0rollup.xsd'), 'imsss_v1p0rollup.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0seqrule.xsd'), 'imsss_v1p0seqrule.xsd');
		$zipfile->add_file(file_get_contents(AT_INCLUDE_PATH.'ims/imsss_v1p0util.xsd'), 'imsss_v1p0util.xsd');

		/* create the archive */

		header('Content-Type: application/octet-stream');
		header('Content-transfer-encoding: binary'); 
		header('Content-Disposition: attachment; filename="'.escapeshellcmd($courseinfo['code']).'_ims.zip"');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');


		echo $zipfile->file();
		break;
	
	default :		
		
		include 'header.php';

		/** Navigator **/
		$menus= array(_ADMINMENU,_SCORMADMIN,_SCORMEXPORT);
		$links=array('index.php?mod=Admin','index.php?mod=SCORM&amp;file=admin','index.php?mod=SCORM&amp;file=export');
		lnBlockNav($menus,$links);
		/** Navigator **/

		OpenTable();
		exportForm();
		CloseTable();

		include 'footer.php';
}
/* - - - - - - - - - - - */

function exportForm() {
	
		list($dbconn) = lnDBGetConn();
		$lntable = lnDBGetTables();

		$coursestable = $lntable['courses'];
		$coursescolumn = &$lntable['courses_column'];
		$query = "SELECT  $coursescolumn[cid],$coursescolumn[code],$coursescolumn[title] 
											  FROM  $coursestable 
											  ORDER BY $coursescolumn[cid]";
		$result = $dbconn->Execute($query);
?>
		<TABLE WIDTH=98% BORDER=0 CELLSPACING=0 CELLPADDING=3>	
		<TR>
			<TD>
			<IMG SRC="images/global/bul.jpg" WIDTH="8" HEIGHT="8" BORDER="0" ALT="">
			<FONT COLOR="#336666"><B><?=_EXPORTCOURSE?></B></FONT>
			<BR><BR><?=_EXPORTDESC?>
			<BR><BR>

			<CENTER>
			<FORM NAME="ImportForm" METHOD="post" ACTION="index.php" ENCTYPE="multipart/form-data">
			<INPUT TYPE="hidden" NAME="mod" VALUE="SCORM">
			<INPUT TYPE="hidden" NAME="file" VALUE="export">
			<INPUT TYPE="hidden" NAME="op" VALUE="export_course">
			
			<TABLE>
			<TR>
			<TD><?=_COURSESELECT?></TD>
			<TD>
			<SELECT NAME="cid">
			<?
				while (list($cid,$code,$title) = $result->fields) {
					$result->MoveNext();
					echo '<OPTION VALUE="'.$cid.'">'.$title.'</OPTION>';
				}
			?>
			</SELECT>
			</TD>
			</TR>
			<TR>
			<TD>&nbsp;</TD><TD><BR><INPUT TYPE="submit" VALUE="<?=_EXPORTCOURSE?>" class="button_org"></TD>
			</TR>
			</TABLE>
			</CENTER>
			</FORM>

			</TD>
		</TR>
		</TABLE>
<?
}

?>