// Video properties
function SpawVideoPropDialog()
{
}

SpawVideoPropDialog.init = function() 
{

  // size preview box
  document.getElementById("img_preview_sizer").height = document.getElementById("img_preview_box").offsetHeight - document.getElementById("img_data").offsetHeight - 10;  

  var iProps = spawArguments;
  if (iProps)
  {
    // set attribute values
    if (iProps.width) {
      var wd = iProps.width;
      if (isNaN(wd) && wd.indexOf("px") != -1)
        wd = wd.substring(0, wd.length-2);
      document.getElementById('cwidth').value = wd;
    }
    if (iProps.height) {
      var ht = iProps.height;
      if (isNaN(ht) && ht.indexOf("px") != -1)
        ht = ht.substring(0, ht.length-2);
      document.getElementById('cheight').value = ht;
    }
    SpawVideoPropDialog.setAspectRatio();
    if (iProps.src) {
      document.getElementById('csrc').value = spawEditor.getStrippedAbsoluteUrl(iProps.src, true);
      SpawVideoPropDialog.previewImage(document.getElementById('csrc').value);
    }
    
    SpawVideoPropDialog.setAlign(iProps.align);
    
    if (iProps.alt) {
      document.getElementById('calt').value = iProps.alt;
    }
    if (iProps.title) {
      document.getElementById('ctitle').value = iProps.title;
    }
    if (iProps.border) {
      document.getElementById('cborder').value = iProps.border;
    }
    if (iProps.hspace && iProps.hspace>-1) {
      document.getElementById('chspace').value = iProps.hspace;
    }
    if (iProps.vspace && iProps.vspace>-1) {
      document.getElementById('cvspace').value = iProps.vspace;
    }
  }
  
  //SpawDialog.resizeDialogToContent();
}

SpawVideoPropDialog.validateParams = function()
{
  // check width and height
  if (isNaN(parseInt(document.getElementById('cwidth').value)) && document.getElementById('cwidth').value != '')
  {
    alert(spawErrorMessages['error_width_nan']);
    document.getElementById('cwidth').focus();
    return false;
  }
  if (isNaN(parseInt(document.getElementById('cheight').value)) && document.getElementById('cheight').value != '')
  {
    alert(spawErrorMessages['error_height_nan']);
    document.getElementById('cheight').focus();
    return false;
  }
  if (isNaN(parseInt(document.getElementById('cborder').value)) && document.getElementById('cborder').value != '')
  {
    alert(spawErrorMessages['error_border_nan']);
    document.getElementById('cborder').focus();
    return false;
  }
  if (isNaN(parseInt(document.getElementById('chspace').value)) && document.getElementById('chspace').value != '')
  {
    alert(spawErrorMessages['error_hspace_nan']);
    document.getElementById('chspace').focus();
    return false;
  }
  if (isNaN(parseInt(document.getElementById('cvspace').value)) && document.getElementById('cvspace').value != '')
  {
    alert(spawErrorMessages['error_vspace_nan']);
    document.getElementById('cvspace').focus();
    return false;
  }
  
  return true;
}

SpawVideoPropDialog.videoBrowseClick = function() 
{
  SpawEngine.openDialog('spawfm', 'spawfm', spawEditor, document.getElementById('csrc').value, 'type=video', 'SpawVideoPropDialog.videoBrowseClickCallback', null, null,paths);
}
SpawVideoPropDialog.videoBrowseClickCallback = function(editor, result, tbi, sender)
{
  document.getElementById('csrc').value = result;
  window.focus();
  document.getElementById('csrc').focus();
  SpawVideoPropDialog.previewImage(document.getElementById('csrc').value, 0);
}

////////////////////********************
SpawVideoPropDialog.submitClick = function()
{  
   // validate paramters

    var pdoc = spawEditor.getActivePageDoc();
    var iProps = spawArguments; //no use
	
	var width, height, src;
	width = document.getElementById('cwidth').value;
    height = document.getElementById('cheight').value;
    src = document.getElementById('csrc').value;

	//var pdoc = spawEditor.getActivePageDoc();
    var embed = spawEditor.getSelectedElementByTagName("embed");

    if (!embed)
    {
      embed = pdoc.createElement("EMBED");
	  embed.setAttribute('width',width);
	  embed.setAttribute('height',height);
	  embed.setAttribute('type','application/');
	  embed.setAttribute('src',src);

      spawEditor.insertNodeAtSelection(embed);
	 }
    
    if (spawArgs.callback)
    {
      eval('window.opener.'+spawArgs.callback + '(spawEditor, iProps, spawArgs.tbi, spawArgs.sender)');
    }
    window.close();
	
}


SpawVideoPropDialog.cancelClick = function() {
  window.close();
}


SpawVideoPropDialog.setAlign = function(alignment)
{
  for (i=0; i<document.getElementById('calign').options.length; i++)  
  {
    al = document.getElementById('calign').options.item(i);
    if (al.value == alignment.toLowerCase()) {
      document.getElementById('calign').selectedIndex = al.index;
    }
  }
}
SpawVideoPropDialog.previewImgObj = null;
SpawVideoPropDialog.previewImage = function(img_src, time_elapsed) 
{
  if (!time_elapsed)
    time_elapsed = 0;
  if (time_elapsed == 0) 
  {
    SpawVideoPropDialog.previewImgObj = new Image();
    SpawVideoPropDialog.previewImgObj.src = img_src;
  }
  if (!SpawVideoPropDialog.previewImgObj.complete) 
  {
    if (time_elapsed < 2000)
    {
      setTimeout('SpawVideoPropDialog.previewImage("'+img_src+'", ' + (time_elapsed + 100) + ')', 100);
      return false;
    }
  }
  // show preview image
  if (SpawVideoPropDialog.previewImgObj.complete && SpawVideoPropDialog.previewImgObj.width>0 && SpawVideoPropDialog.previewImgObj.height>0)
  {
    var maxwidth = 200;//document.getElementById("img_preview_placeholder").offsetWidth - 2;
    var maxheight = document.getElementById("img_preview_box").offsetHeight - document.getElementById("img_data").offsetHeight - 20;
    var w = SpawVideoPropDialog.previewImgObj.width;
    var h = SpawVideoPropDialog.previewImgObj.height;
    
    // calculate resize ratio
    var ratio = 1;
    if (w > maxwidth) ratio = w / maxwidth;
    if (h > maxheight && h/maxheight > ratio) ratio = h/maxheight;
    
    var imgelm = document.getElementById('img_preview');
    imgelm.src = SpawVideoPropDialog.previewImgObj.src;
    imgelm.width = Math.round(w / ratio);
    imgelm.height = Math.round(h / ratio);
    var dimensions = document.getElementById("img_dimensions");
    dimensions.innerHTML = SpawVideoPropDialog.previewImgObj.width + "x" + SpawVideoPropDialog.previewImgObj.height;
    if (document.getElementById('cwidth').value == '' && document.getElementById('cheight').value == '')
    {
      document.getElementById('cwidth').value = SpawVideoPropDialog.previewImgObj.width;
      document.getElementById('cheight').value = SpawVideoPropDialog.previewImgObj.height;
      SpawVideoPropDialog.setAspectRatio();
    }

    document.getElementById('img_preview_placeholder').style.visibility = 'visible';
    document.getElementById('img_data').style.visibility = 'visible';
  }
  else
  {
    // timeout or broken url
    document.getElementById('img_preview_placeholder').style.visibility = 'hidden';
    document.getElementById('img_data').style.visibility = 'hidden';
  }
}

SpawVideoPropDialog.resetDimensions = function()
{
  if (SpawVideoPropDialog.previewImgObj.complete && SpawVideoPropDialog.previewImgObj.width>0 && SpawVideoPropDialog.previewImgObj.height>0)
  {
    document.getElementById("cwidth").value = SpawVideoPropDialog.previewImgObj.width;
    document.getElementById("cheight").value = SpawVideoPropDialog.previewImgObj.height;
    SpawVideoPropDialog.setAspectRatio();
  }
  return false;
} 

SpawVideoPropDialog.aspectRatio = 0;
SpawVideoPropDialog.setAspectRatio = function()
{
  if (!isNaN(document.getElementById('cwidth').value) && !isNaN(document.getElementById('cheight').value))
  {
    SpawVideoPropDialog.aspectRatio = parseFloat(document.getElementById('cwidth').value)/parseFloat(document.getElementById('cheight').value);
  }
}
SpawVideoPropDialog.widthChanged = function()
{
  if (document.getElementById("cproportions").checked && SpawVideoPropDialog.aspectRatio != 0)
  {
    var width = parseInt(document.getElementById("cwidth").value);
    document.getElementById("cheight").value = Math.round(width/SpawVideoPropDialog.aspectRatio);
  }
}

SpawVideoPropDialog.heightChanged = function()
{
  if (document.getElementById("cproportions").checked && SpawVideoPropDialog.aspectRatio != 0)
  {
    var height = parseInt(document.getElementById("cheight").value);
    document.getElementById("cwidth").value = Math.round(height*SpawVideoPropDialog.aspectRatio);
  }
}
SpawVideoPropDialog.proportionsClick = function()
{
  if (document.getElementById("cproportions").checked)
  {
    // set new aspect ratio
    SpawVideoPropDialog.setAspectRatio();
  }
}

if (document.attachEvent)
{
  // ie
  window.attachEvent("onload", new Function("SpawVideoPropDialog.init();"));
}
else
{
  window.addEventListener("load", new Function("SpawVideoPropDialog.init();"), false);
}
